﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Newtonsoft.Json;
using System.Net.Http;


namespace TestMidasAPI
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
       
        class Node
        {
            public int X { get; set; }
            public int Y { get; set; }
            public int Z { get; set; }
        }

        class BeamData
        {
            public string TYPE { get; set; }
            public int MATL { get; set; }
            public int SECT { get; set; }
            public List<int> NODE { get; set; }
            public int ANGLE { get; set; }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            postNode();
            MessageBox.Show("完成节点创建！");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            postElement();
            MessageBox.Show("完成单元创建！");
        }

        static async Task postNode()
        {
            string ulr = "https://api-beta.midasit.cn:443/gen";

            string APIKey =
                "你自己的的APIKEY";

            Dictionary<int, Node> Assign = new Dictionary<int, Node>();

            Assign.Add(1, new Node { X = 0, Y = 0, Z = 0 });
            Assign.Add(2, new Node { X = 0, Y = 0, Z = 3 });
            Assign.Add(3, new Node { X = 3, Y = 0, Z = 3 });
            Assign.Add(4, new Node { X = 3, Y = 0, Z = 0 });

            var result = new { Assign };
            string json = JsonConvert.SerializeObject(result);
            using (HttpClient client = new HttpClient())
            {
                client.DefaultRequestHeaders.Add("MAPI-Key", APIKey);
                var content = new StringContent(json, Encoding.UTF8, "application/json");
                HttpResponseMessage response = await client.PostAsync(ulr + "/db/node", content);

                string responseContent = await response.Content.ReadAsStringAsync();
            }

        }

        static async Task postElement()
        {
            string ulr = "https://api-beta.midasit.cn:443/gen";

            string APIKey =
                "你自己的的APIKEY";

            Dictionary<int, BeamData> Assign = new Dictionary<int, BeamData>();

            BeamData element1 = new BeamData
            {
                TYPE = "BEAM",
                MATL = 1,
                SECT = 1,
                NODE = new List<int> { 1, 2 },
                ANGLE = 0,
            };

            BeamData element2 = new BeamData
            {
                TYPE = "BEAM",
                MATL = 1,
                SECT = 1,
                NODE = new List<int> { 2, 3 },
                ANGLE = 0,
            };
            BeamData element3 = new BeamData
            {
                TYPE = "BEAM",
                MATL = 1,
                SECT = 1,
                NODE = new List<int> { 3, 4 },
                ANGLE = 0,
            };

            Assign.Add(1, element1);
            Assign.Add(2, element2);
            Assign.Add(3, element3);
            var result = new { Assign };
            string json = JsonConvert.SerializeObject(result);
            using (HttpClient client1 = new HttpClient())
            {
                client1.DefaultRequestHeaders.Add("MAPI-Key", APIKey);
                var content = new StringContent(json, Encoding.UTF8, "application/json");
                HttpResponseMessage response1 = await client1.PostAsync(ulr + "/db/elem", content);
                string responseContent1 = await response1.Content.ReadAsStringAsync();
            }

            
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
